# Introduction

These instructions will allow you to test the e-voting system in a local development environment. The possibility of running end-to-end tests shall
provide researchers with a better understanding of the cryptographic protocol and facilitate public scrutiny. The **development** environment
does **not** represent Swiss
Post's [productive environment](https://gitlab.com/swisspost-evoting/e-voting/e-voting-documentation/-/blob/master/Operations/Infrastructure%20whitepaper%20of%20the%20Swiss%20Post%20voting%20system.md)
and omits numerous security elements such as HTTP security headers, separate network zones, and a web application firewall.

## E-voting supported versions

The following table indicates the versions of the e-voting system that can be used to run these end-to-end tests.

| [E-voting](https://gitlab.com/swisspost-evoting/e-voting/e-voting) version                  |
|---------------------------------------------------------------------------------------------|
| [0.15.2.1](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-0.15.2.1) |
| [0.15.3.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-0.15.3.0) |
| [1.0.0.2](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.0.0.2)   |
| [1.2.0.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.2.0.0)   |
| [1.3.0.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.3.0.0)   |
| [1.3.1.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.3.1.0)   |
| [1.3.2.1](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.3.2.1)   |
| [1.3.3.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.3.3.0)   |
| [1.3.4.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.3.4.0)   |
| [1.4.0.1](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.0.1)   |
| [1.4.2.1](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.2.1)   |
| [1.4.3.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.3.0)   |
| [1.4.3.1](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.3.1)   |
| [1.4.4.0](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.4.0)   |
| [1.4.4.1](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.4.1)   |
| [1.4.4.2](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.4.2)   |
| [1.4.4.3](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.4.3)   |
| [1.4.4.4](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/tree/e-voting-1.4.4.4)   |

## Prerequisites

- **Windows OS**

  The e-voting end-to-end environment requires to be run from a Windows machine since the Secure Data Manager components are only available for
  Windows.
  <br>

- **Built e-voting system**

  To set up a working e-voting end-to-end test, you need to build the e-voting system itself. For that please refer to
  the [building guide](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/blob/master/BUILDING.md) of e-voting.
  <br>

- **Folder structure**

  Once you followed
  the [building guide](https://gitlab.com/swisspost-evoting/e-voting/e-voting/-/blob/master/BUILDING.md) of e-voting,
  you should have a folder with the following structure:

  ```
  <DIRECTORY>
  │   build.tar.gz (This archive is generated by the evoting-build Docker image)
  │   e2e.sh
  ```

  In the case you didn't use the provided Docker image, ensure to have the following folder structure:

  ```
  <DIRECTORY>
  │   e-voting/ (built)
  |   verifier/ (built)
  |   data-integration-service/ (built)
  │   evoting-e2e-dev/
  │   e2e.sh (initially located in evoting-e2e-dev/scripts/)
  ```
  <br>

- **Install Docker Desktop on Windows**

  The e-voting end-to-end test environment requires Docker to deploy services in Docker containers. Therefore, you need to install Docker on the
  machine that will run the end-to-end.

  Follow the instructions here: [Install Docker Desktop on Windows](https://docs.docker.com/desktop/install/windows-install/)
  <br>

- **Have a Unix shell**

  To easily configure the e-voting end-to-end environment, various Linux commands are useful. Therefore, you need to have a Unix shell available on the
  Windows machine. You can, for example, use the [portable Git-bash](https://git-scm.com/download/win).
  <br>

- **Memory requirements**

  Please take into consideration that running the entire E-voting system, which comprises multiple components, on a single machine can be quite
  memory-intensive. To ensure smooth operation, we recommend configuring Docker with a minimum of 30 GB of RAM. Moreover, the execution of the Secure
  Data Manager requires an additional minimum of 20GB of RAM.  
  <br>

## Build, configure and start all services

Once you fulfill all prerequisites, you can run the `e2e.sh` script in an administrative Unix shell under your Windows machine. If you don't want to run the script in an
administrative shell, you can also run the script as a normal user. In this case, the script will not create shortcuts for easy access to the
different services.

```sh
./e2e.sh
```

This script builds and deploys all services of the e-voting system. It also creates, in the folder containing the e2e.sh script, a
folder `secure-data-manager` containing the preconfigured Secure Data Manager instance.

Moreover, once the script has built and deployed all e-voting services, it starts to listen to the output logs of the Docker containers.

As soon as all services are healthy, you can go to the next section. To check if all services are healthy, you can inspect the result of the following
command:

```sh
docker ps
```

### Extra Information: Additional manual configuration of the Secure Data Manager (ONLINE mode) when running the docker services on a different machine

In the case you want to execute the services on a different machine for any specific reasons, let's say on a `DOCKER_SERVER_INSTANCE`, it will be
necessary to modify the `Voter Portal URL` default setting for the ONLINE mode. When running the Secure Data Manager launcher and selecting the
ONLINE mode, replace the default configuration of the setting from `localhost` with the IP address of the alternate machine:

```sh
http://DOCKER_SERVER_INSTANCE_IP:7000
```

## Run an Election Event

In order to carry out an election event, please follow the [Run Election Event-Guide.](docker-compose/Run_Election_Event.md)
